/*
 * File: BasePlayer.h
 *
 * Description: Implements basic player skills such as walking, kicking etc.
 *
 * Author: UI-AI 3D Robocup Soccer Team <ui_3dsoccer@eng.ui.ac.ir>, (c) 2007
 *
 */

/*
    Copyright (C) 2009  UI-AI 3D Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BASEPLAYER_H_
#define BASEPLAYER_H_

#include "BaseAgent.h"

class BasePlayer : public BaseAgent
{
    public:
        enum ActionType
        {
            WALK,
            RESET
        };

    public:
        BasePlayer();
        virtual ~BasePlayer();

    protected:
        bool MoveTo(const PolarVector3D &target);
        bool Turn(AngDeg angle);
        void Walk();
        void SideWalk(direction dir);
        bool Kick();
        void GetUp();
        AngDeg WhatAngleToTurnToPos(const Vector3D &target);
        void TestAct();
};

#endif /*BASEPLAYER_H_*/
