/*
 * File: Player.h
 *
 * Description: High level player implementation
 *
 * Author: UI-AI 3D Robocup Soccer Team <ui_3dsoccer@eng.ui.ac.ir>, (c) 2007
 *
 */

/*
    Copyright (C) 2009  UI-AI 3D Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef PLAYER_H_
#define PLAYER_H_

#include "BasePlayer.h"

class Player : public BasePlayer
{
    public:
        enum ActionMode {
            PLAY,
            PENALTY,
            CUSTOM,
            NOTHING
        };

        Player(const string teamName);
        virtual ~Player();

        void SetActMode( ActionMode act );
        void SetTeamName( const string teamName );

    private:
        ActionMode act;

        void Think();
        void Play();
        void TestPlay();
};

#endif /*PLAYER_H_*/
