/*
 * File: SoccerTypes.h
 *
 * Description: Global types which doesn't have any better place!
 *
 * Author: UI-AI 3D Robocup Soccer Team <ui_3dsoccer@eng.ui.ac.ir>, (c) 2007
 *
 */

/*
    Copyright (C) 2009  UI-AI 3D Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SOCCERTYPES_H_
#define SOCCERTYPES_H_

enum VisionObject
{
    FLAG_RIGHT_US,
    FLAG_RIGHT_THEM,
    FLAG_LEFT_US,
    FLAG_LEFT_THEM,
    GOAL_RIGHT_US,
    GOAL_RIGHT_THEM,
    GOAL_LEFT_US,
    GOAL_LEFT_THEM,
    BALL,
    TEAMMATE_1,
    TEAMMATE_2,
    TEAMMATE_3,
    TEAMMATE_4,
    TEAMMATE_5,
    TEAMMATE_6,
    TEAMMATE_7,
    TEAMMATE_8,
    TEAMMATE_9,
    TEAMMATE_10,
    TEAMMATE_11,
    OPPONENT_1,
    OPPONENT_2,
    OPPONENT_3,
    OPPONENT_4,
    OPPONENT_5,
    OPPONENT_6,
    OPPONENT_7,
    OPPONENT_8,
    OPPONENT_9,
    OPPONENT_10,
    OPPONENT_11,
    ILLEGAL_OBJECT
};

enum PlayModeType
{
    BEFORE_KICKOFF,
    KICKOFF_US,
    KICKOFF_THEM,
    PLAYON,
    KICKIN_US,
    KICKIN_THEM,
    CORNER_KICK_US,
    CORNER_KICK_THEM,
    GOAL_KICK_US,
    GOAL_KICK_THEM,
    FREE_KICK_US,
    FREE_KICK_THEM,
    GOAL_US,
    GOAL_THEM,
    OFFSIDE_US,
    OFFSIDE_THEM,
    GAME_OVER,
    UNKNOWN_PLAYMODE
};

enum direction
{
    RIGHT,
    LEFT
};

class Types
{
    public:
        static bool IsFlag(VisionObject ob)
        {
            return ob >= FLAG_RIGHT_US && ob <= GOAL_LEFT_THEM;
        }

        static bool IsTeammate(VisionObject ob)
        {
            return ob >= TEAMMATE_1 && ob <= TEAMMATE_11;
        }

        static bool IsOpponent(VisionObject ob)
        {
            return ob >= OPPONENT_1 && ob <= OPPONENT_11;
        }
};

#endif /*SOCCERTYPES_H_*/
